Unit AEE3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AMA1R_p;

procedure AEE3R(var A :Array of Real; var B :Array of Real;
                N :Integer; var RU :Array of Real;
                var W :Array of Real; K :Integer);

implementation

procedure AEE3R(var A :Array of Real; var B :Array of Real;
                N :Integer; var RU :Array of Real;
                var W :Array of Real; K :Integer);
var
I,I1,I2,J,D,E,F,G,N1,P1 :Integer;
S,L,M,O,U,Y,Z,EPS,WMIN2,HM :Real;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
WMIN2 := SYS051;
W[0] := A[0];
if ( N = 1 ) 
 then goto _12;
AMA1R(A,B,N,L,M,HM,P1);
for I:=1 to K do
 begin
  W[I-1] := L;
_1:
  RU[I-1] := M;
 end;
EPS := EMax1(Abs(M),Abs(L))*WMIN2;
S := 2.0*WMIN2;
N1 := K+1;
for I1:=1 to K do
 begin
  D := N1-I1;
  L := W[D-1];
  Z := RU[D-1];
  if ( M > Z ) 
   then M := Z;
  I2 := 1+D;
  for E:=1 to D do
   begin
    I := I2-E;
    if ( L >= W[I-1] ) 
     then goto _2;
    L := W[I-1];
    goto _3;
_2:
   end;
_3:
  O := (L+M)*0.5;
  if ( M-L <= (Abs(M)+Abs(L))*S+EPS ) 
   then goto _9;
  F := 0;
  Y := A[0]-O;
  if ( Y < 0.0 ) 
   then F := 1;
  for J:=2 to N do
   begin
    U := B[J-1];
    if ( Y <> 0.0 ) 
     then goto _4;
    Z := Abs(U)/WMIN2;
    goto _5;
_4:
    Z := (U/Y)*U;
_5:
    Y := A[J-1]-O-Z;
    if ( Y < 0.0 ) 
     then F := F+1;
_6:
   end;
  if ( F >= D ) 
   then goto _8;
  L := O;
  if ( F >= 1 ) 
   then goto _7;
  W[0] := O;
  goto _3;
_7:
  G := F+1;
  W[G-1] := O;
  if ( RU[F-1] > O ) 
   then RU[F-1] := O;
  goto _3;
_8:
  M := O;
  goto _3;
_9:
  W[D-1] := O;
_10:
 end;
if ( P1 = 0 ) 
 then goto _12;
HM := 1.0/HM;
for I:=1 to K do
 begin
_11:
  W[I-1] := W[I-1]*HM;
 end;
_12:
end;

end.
